<?php
/*

Plugin Name: Static  Pages
Description: Static  Pages
Version: 0.3
GS : 3.0
Author: Johannes Pretorius
Author URI: http://www.dominion-it.co.za/

*/
# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, 	# ID of plugin, should be filename minus php
	'Static  Pages', 	# Title of plugin
	'0.3', 		# Version of plugin
	'Johannes Pretorius',	# Author of plugin
	'http://www.dominion-it.co.za/', 	# Author URL
	'Static  Pages gets generated in /plugings/dominion_static_pages/static/', 	# Plugin Description
	'plugins', 	# Page type of plugin
	'dominion_staticpage_config'  	# Function that displays content
);





# actions
add_action('changedata-aftersave','dominion_static_pagechanged');
add_action('plugins-sidebar','createSideMenu',array($thisfile,'Static Pages')); //to allow configuration


function dominion_static_pagechanged(){
  global $SITEURL;
  $id = $_POST['post-id'];
  require_once(GSPLUGINPATH.'dominion-it-shared/http_files.php');
  $cfgFile = GSPLUGINPATH."config/_global/dominion-static/static-config.cfg";
  $targetsite = 'http://wwww.notsetup.please.use.admin.plugin.static.sites/';
  $auto = 0;
  if (is_file($cfgFile )) {
    $cfg = parse_ini_file($cfgFile);
	$targetsite = $cfg['targetsite'];
	$auto = $cfg['auto'];
  }  
  get_file($SITEURL."index.php?id=$id",GSPLUGINPATH."dominion_static_pages/static/$id.html",true);
  $html = file_get_contents(GSPLUGINPATH."dominion_static_pages/static/$id.html");
  $html = replaceAnchorsWithPage($html,$targetsite);
  file_put_contents(GSPLUGINPATH."dominion_static_pages/static/$id.html",$html);
  if ($auto == 1) {
	  if (!send_file(GSPLUGINPATH."dominion_static_pages/static/$id.html",$targetsite."plugins/dominion_static_pages/upload/dominion_staticupload.php",'staticfile')) {
		error_log('Error uploading. check server name make sure there is a  / at the end and that plugin is installed in plugins folder of target server also.');
	  }
  }
}


function replaceAnchorsWithPage($html,$baseURL) {
	$regex = '/href=[\'"]+?.*?[\'"]/i'; //kry die skakel
    preg_match_all($regex, $html,$tmpArr,PREG_PATTERN_ORDER);
	global $SITEURL;
	foreach ($tmpArr[0] as $key => $data) {
	   $newData = $data;
	   $newData = str_replace($SITEURL,$baseURL,$newData);
	   $i = strpos($newData,'/index.php?id=');
	   if ($i ===  false) {
	     $arrReplace[$key] =  $newData;   
	   } else {
	     $hfile = substr($newData,$i+14);
		 $hfile= str_replace('"','',$hfile);
		 $hfile= str_replace("'",'',$hfile);
		 $newData = substr_replace($newData,"/$hfile.html\"",$i);
	   }
	   $data= str_replace('/','\/',$data);
	   $data= str_replace('?','\?',$data);
	   $regex = "/$data+?/i"; //kry die skakel
	   $html = preg_replace($regex,$newData,$html);
	}
	return $html;
}

function dominion_staticpage_createstatics_for_dir(){
}
function dominion_staticpage_config(){
  //constants
  $msg = '';
  $targetsite = 'http://www.example.com/';
  $cfgFile = GSPLUGINPATH."config/_global/dominion-static/static-config.cfg";
  $passwordFile = GSPLUGINPATH."dominion_static_pages/upload/secret/secret.cfg";
  $pswStatus = (is_file($passwordFile))?"Password Already set.":'';
  
  if (!class_exists ( 'ZipArchive' , false)) {
	  include('inc/ZipArchive.php');
  }
  $nopZip = '';
  if (!class_exists ( 'ZipArchive' , false)) {
	  $nopZip = "PHP Package ZipArchive needs to included, please view your webhealth check.";
  }  
  //set paths ready
  if (!(is_dir(GSPLUGINPATH."config/_global/dominion-static/"))) {
    mkdir(GSPLUGINPATH."config/_global/dominion-static/",0777,true); //create whole dir structure as needed
  }
  
  //save password if given in password file.
  if (isset($_POST['savepswd'])) {
     $psw = $_POST['psw'];
	 file_put_contents($passwordFile,sha1($psw));
  }
  
  //save settigns
  if (isset($_POST['save'])) {
    $str = "targetsite=".add_remove_SlashAtEndofPathorURL($_POST['server']).PHP_EOL;
	$a = isset($_POST['auto'])?'1':'0';
    $str .= "auto=$a".PHP_EOL;
	file_put_contents($cfgFile,$str); 
	$msg = 'Remember to Recreate all pages if target server was changed.';
  }   
  //read settings
  if (is_file($cfgFile )) {
    $cfg = parse_ini_file($cfgFile);
	$targetsite = $cfg['targetsite'];
	$auto = (isset($cfg['auto']) && $cfg['auto'] == 1)?'checked="checked"':'';
  }
  
  //recreate all static files
  if (isset($_POST['recreate'])) {
	  require_once(GSPLUGINPATH.'dominion-it-shared/http_files.php');
	  $files = scandir(GSDATAPAGESPATH);
	  global $SITEURL;  
	  removeFilesofExtinDirectory(GSPLUGINPATH."dominion_static_pages/static/","html",true); //remove all previous web files.
	  //cloneDirectoryStructure(GSDATAPAGESPATH,GSPLUGINPATH."dominion_static_pages/static/"); //created same dir structure as pages dir.
	  foreach ($files as $file){
		if (strpos($file,'.xml') > 0) {
		   
		  $id = strpos($file,'.xml');
		  $id = substr($file,0,$id);
		  get_file($SITEURL."index.php?id=$id",GSPLUGINPATH."dominion_static_pages/static/$id.html",true);
		  $html = file_get_contents(GSPLUGINPATH."dominion_static_pages/static/$id.html");
		  $html = replaceAnchorsWithPage($html,$targetsite);
		  file_put_contents(GSPLUGINPATH."dominion_static_pages/static/$id.html",$html);
		}
	  }
	  $msg = 'All pages recreated';
  }
  
  if (isset($_POST['uploadfiles']) ) {
      require_once(GSPLUGINPATH.'dominion-it-shared/http_files.php');
	  $files = scandir(GSPLUGINPATH."dominion_static_pages/static/");
	  $msg = 'Files have been uploaded.';
      $fldData['wagwoord'] = (is_file($passwordFile))?file_get_contents($passwordFile):'';
	  $fldData['aksie'] = 'html';	  
	  foreach ($files as $file){
		if (strpos($file,'.html') > 0) {
		  
		  
		  if (!send_file(GSPLUGINPATH."dominion_static_pages/static/$file",$targetsite."plugins/dominion_static_pages/upload/dominion_staticupload.php",'staticfile',$fldData)) {
		    $msg = 'Error uploading. check server name make sure there is a  / at the end and that plugin is installed in plugins folder of target server also.';
			break;
		  }
		}
	  }  
    
  }
  
  if (isset($_POST['uploadtheme']) && $nopZip == '') {
    global $TEMPLATE;
	if (is_file(GSPLUGINPATH."dominion_static_pages/theme/theme.zip")) {
	  unlink(GSPLUGINPATH."dominion_static_pages/theme/theme.zip");
	}
	new ZipFolder(GSPLUGINPATH."dominion_static_pages/theme/theme.zip", "../theme/".$TEMPLATE);
    require_once(GSPLUGINPATH.'dominion-it-shared/http_files.php');
	$msg = 'Theme have been uploaded.';
    $fldData['wagwoord'] = (is_file($passwordFile))?file_get_contents($passwordFile):'';
	$fldData['aksie'] = 'theme';	  
    if (!send_file(GSPLUGINPATH."dominion_static_pages/theme/theme.zip",$targetsite."plugins/dominion_static_pages/upload/dominion_staticupload.php",'staticfile',$fldData)) {
	   $msg = 'Error uploading. check server name make sure there is a  / at the end and that plugin is installed in plugins folder of target server also.';
    }
  }  
  global $SITEURL;
  $websitezipurl = $SITEURL.'plugins/dominion_static_pages/work/webzip.php';
?>
<div><p>Add and save the target server that all the static pages must point to. Also this will be the server url used for uploads. Select
auto updates if you want on page saves the target server to be updated with the latest saved page. Note if Theme is changed or targer server, please
recreate all pages to insure that the html files points to the correct theme and link urls to correct server.
</p><p>Version : 0.3 by Johannes Pretorius. - <a href='http://get-simple.info/forum/topic/2273/static-pages-plugin/'>Support Forum</a></p></div>
<div style='margin-top:10px;color:red'><p><?php echo $nopZip;?></p></div>
<div style='margin-top:10px;border:none;'><form method='post'>Password <input type='text' size='40' name='psw' value=''><input style='padding:2px;margin-left:10px;' type='submit' value='Save' name='savepswd'><span style='color:blue;margin-left:5px;'><?php echo $pswStatus;?></span></form></div>
<div style='padding:5px;margin:10px;border:1px solid black;'><form method='post'>Target server  <input type='text' size='40' name='server' value='<?php echo $targetsite;?>'><br/>Auto upload on page update : <input <?php echo $auto; ?> type='checkbox' name='auto' value='1'><input style='padding:2px;margin-left:10px;' type='submit' value='Save' name='save'></form></div>
<div style='margin-top:10px;border:none;'><form method='post'><input style='padding:5px;' type='submit' name='recreate' value='Recreate all pages'>
                     <input style='margin-left:3px;padding:5px;' type='submit' name='uploadfiles' value='Upload all pages'>
					 <input style='margin-left:3px;padding:5px;' type='submit' name='uploadtheme' value='Upload Active Theme'>
					  </form></div>
<div><a  href='<?php echo $websitezipurl;?>' target='webzip'>Download Website Zip file</a> - This can be used as a basis for a new site (Do this after password was set)</div>					  
<div style='margin-top:10px;color:red'><p ><?php echo $msg; ?></p></div>
<?php  
}
?>